import unittest
from random import randint

from euclides import gcd
from math import gcd as gcd_math


class TestGCD(unittest.TestCase):
    def setUp(self):
        self.fixed_args = [(10, 7, 1), (20, 10, 10), (-5, 15, 5), (-13, -7, 1), (100, -32, 4)]
        a, b, n = -1000, 1000, 1000
        self.random_args = [(randint(a, b), randint(a, b)) for _ in range(n)]

    def test_of_gcd_fixed(self):
        for a, b, d in self.fixed_args:
            self.assertEqual(gcd(a, b), d)


    def test_of_gcd_random(self):
        for a, b in self.random_args:
            self.assertEqual(gcd(a, b), gcd_math(a, b))


if __name__ == "__main__":
    unittest.main()
